<template>
  <q-tr>
    <td>
      <router-link v-if="data.level == 6"
                   :to="{ name: 'report-member-with-member' , params: { id: data.id, username: data.username}, query: { ...filter } }">
        {{ data.username }}
      </router-link>
      <router-link v-else-if="$route.meta.level == 6 && data.level < 6"
                   :to="{ name: 'report-child-member' , params: { id: data.id  } , query: { ...filter }}">
        {{ data.username }}
      </router-link>
      <router-link v-else-if="data.level < 6"
                   :to="{ name: 'report-child' , params: { id: data.id,  username: data.username } , query: { ...filter }}">
        {{ data.username }}
      </router-link>
    </td>
    <td>{{ data.role }}</td>
    <td class="text-center">{{ data.currency }}</td>
    <td class="text-right">{{ numberFormat(data.member.bet, 0 , true) }}</td>
    <td class="text-center">{{ numberFormat(data.member.count, 0 ) }}</td>
    <td>
      <p v-if="role < 2 && data.upLine.percent > 0">Provider: {{ data.upLine.percent }}%</p>
      <p v-if="role < 2 && data.company.percent > 0">Smart Bet: {{ data.company.percent }}%</p>
      <p v-if="role < 2 && data.owner.percent > 0">คอมปะนี: {{ data.owner.percent }}%</p>
      <p v-if="role >= 2 && data.upLine.percent > 0">คอมปะนี: {{ data.upLine.percent }}%</p>
      <p v-if="role <= 3 && data.share.percent > 0">ผู้ถือหุ้น: {{ data.share.percent }}%</p>
      <p v-if="role <= 4 && data.senior.percent > 0">ซีเนียร์: {{ data.senior.percent }}%</p>
      <p v-if="data.agent.percent > 0">เอเย่น: {{ data.agent.percent }}%</p>
    </td>
    <q-td :class="this.bgFunc(data.member.calWinloss)" class="text-right">{{ data.member.calWinloss }}</q-td>
    <q-td :class="this.bgFunc(data.agent.calWinloss)" v-if="role < 6" class="text-right">{{ data.agent.calWinloss }}</q-td>
    <q-td :class="this.bgFunc(data.senior.calWinloss)" v-if="role < 5" class="text-right">{{ data.senior.calWinloss }}</q-td>
    <q-td :class="this.bgFunc(data.share.calWinloss)" v-if="role < 4" class="text-right">{{ data.share.calWinloss }}</q-td>
    <q-td :class="this.bgFunc(data.owner.calWinloss)" v-if="role < 3" class="text-right">{{ data.owner.calWinloss }}</q-td>
    <q-td :class="this.bgFunc(data.company.calWinloss)" v-if="role < 2" class="text-right">{{ data.company.calWinloss }}</q-td>
    <q-td :class="this.bgFunc(data.upLine.calWinloss)"  class="text-right">{{ data.upLine.calWinloss }}</q-td>
  </q-tr>
</template>
<script>
import {mapState} from "vuex";

export default {
  name: "Report-Member-TR",
  props: {
    row: {
      type: Object,
      default: () => {
        results: []
      }
    },
    filter: {}
  },
  data() {
    return {
      data: {}
    }
  },
  computed: {
    ...mapState('auth', ['role']),
    dateFormat() {
      return (date) => {
        return new Intl.DateTimeFormat("th-TH", {
          calendar: 'iso8601',
          year: 'numeric',
          month: '2-digit',
          day: '2-digit',
          hour: '2-digit',
          minute: '2-digit',
          second: '2-digit',
          hourCycle: 'h23',
        }).format(new Date(date))
      }
    },
    numberFormat() {
      return (number, digit = 2, comma = true) => new Intl.NumberFormat('en-US', {
        minimumFractionDigits: digit,
        maximumFractionDigits: digit,
        useGrouping: comma
      }).format(number);
    },
    convertToFloat() {
      return (number) => parseFloat(this.numberFormat(number, 2, false))
    },
    agentWinloss() {
      return (data) => {
        if (data) {
          return (this.convertToFloat(this.data.member.winLoss) * parseInt(data.percent)) / 100;
        }
        return 0;
      };
    },
    bgFunc() {
      return (inValue) => {
        const value = this.convertToFloat(inValue.replace(/,/g, ''));
        if(value > 0) {
          return "text-green-8 text-bold"
        }
        if (value  == 0) {
          return "";
        }
        return "text-red-10 text-bold"
      }
    }
  },
  created() {
    const {id , username, companyName, startTime, role, level, currency, report, providerCode, bet} = this.row;
    let displayName = username ?? companyName;
    this.data = {
      username: displayName,
      id,
      startTime,
      role,
      currency,
      level,
      providerCode,
      bet
    }
    let model = {bet: 0, winLoss: 0, percent: 0, count: 0}
    this.data.upLine = Object.assign({}, model, report[0]);
    this.data.owner = Object.assign({}, model, report.find(x => x.role == 2));
    this.data.share = Object.assign({}, model, report.find(x => x.role == 3));
    this.data.senior = Object.assign({}, model, report.find(x => x.role == 4));
    this.data.agent = Object.assign({}, model, report.find(x => x.role == 5));
    this.data.member = Object.assign({}, model, report.find(x => x.role == 6));
    this.data.owner.calWinloss = this.numberFormat(this.agentWinloss(this.data.owner));
    this.data.share.calWinloss = this.numberFormat(this.agentWinloss(this.data.share));
    this.data.senior.calWinloss = this.numberFormat(this.agentWinloss(this.data.senior));
    this.data.agent.calWinloss = this.numberFormat(this.agentWinloss(this.data.agent));
    this.data.member.calWinloss = this.numberFormat(this.data.member.winLoss == 0 ? 0 : this.data.member.winLoss * -1);
    if (this.role >= 2) {
      let percents = [];
      if (this.role <= 2) {
        percents.push(this.data.owner);
      }
      if (this.role <= 3) {
        percents.push(this.data.share);
      }
      if (this.role <= 4) {
        percents.push(this.data.senior);
      }
      if (this.role <= 5) {
        percents.push(this.data.agent);
      }
      const percent = (100 - percents.reduce((sum, obj) => {
        if (obj) {
          return sum + obj.percent;
        }
        return sum;
      }, 0));
      this.data.upLine.percent = percent == 100 ? 0 : percent;
      this.data.upLine.calWinloss = this.numberFormat(this.agentWinloss(this.data.upLine))
    } else if (this.role < 2) {
      this.data.company = Object.assign({}, model, report[0]);
      const percent = (100 - [
        this.data.agent,
        this.data.senior,
        this.data.share,
        this.data.owner
      ].reduce((sum, obj) => sum + obj.percent, 0));
      this.data.company.percent = percent == 100 ? 0 : percent;
      this.data.upLine.percent = 0;
      this.data.company.calWinloss = this.numberFormat(this.agentWinloss(this.data.company))
      this.data.upLine.calWinloss = this.numberFormat(this.agentWinloss(this.data.upLine))
    }

    // this.data = {
    //   id,
    //   username,
    //   role,
    //   currency,
    //   member,
    //   upLine,
    //   agent,
    //   senior
    // }
  }
};
</script>
